import FS from 'node:fs'

const isJSON = (s) => {
  try {
    return JSON.parse(s)
  } catch(e) {}
}

const get = async (url, options = {}, after = (x => x)) => {
  const f = await fetch(`https://${url}`, options)
  const s = await f.text()
  return after(isJSON(s) || s)
}

const save = async (o = Error('provide an object or map'), fn = Error('provide a filename')) => {
  const isMap = (o instanceof Map)
  return FS.writeFileSync(`./${fn}`, JSON.stringify(isMap ? Object.fromEntries(o) : o, null, 2))
}

const load = async (fn) => {
  return JSON.parse(FS.readFileSync(fn, 'utf8'))
}

export { isJSON, get, save, load }

if(import.meta.url.endsWith('/instax/index.mjs'))
  console.log('>> ' + await get('httpbin.org/get', {}, x=>x.origin))
